﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Web.Security;
using System.Collections;
using System.Data;

public partial class _Default : System.Web.UI.Page 
{
    private bool loggedIn = false;
    private bool loginFailed = false;
    private int userid;
    private string username;
    private string displayName;
    private string email;
    private bool showEmail;
    private DateTime createDate;
    private int accessLevel;

    public enum var
    {
        GET, POST, SESSION, COOKIE
    }
    public enum clean{
        DB
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        authenticate();

        string content = null;
        content += header();
        content += layout();
        
        if (getVariable("logon", var.GET) == "true" || loginFailed)
        {
            content += showLogon();
        }
        else
        {
            bool showblogs = true;
            int blogID = 0;
            int userUserid = 0;
            switch (getVariable("option", var.GET))
            {
                case "writeBlog":
                case "editBlog":
                    if (accessLevel < 100)
                    {
                        break;
                    }
                    showblogs = false;
                    try
                    {
                        blogID = Convert.ToInt16(getVariable("blogID", var.GET));
                    }
                    catch { }
                    content += writeBlog(blogID);
                    break;
                case "deleteBlog":
                    if (accessLevel < 100)
                    {
                        break;
                    }
                    try
                    {
                        blogID = Convert.ToInt16(getVariable("blogID", var.GET));
                    }
                    catch { }
                    content += deleteBlog(blogID);
                    break;
                case "userManagement":
                case "editUser":
                    if (accessLevel < 255)
                    {
                        break;
                    }
                    try
                    {
                        userUserid = Convert.ToInt16(getVariable("userid", var.GET));
                    }
                    catch { }
                    showblogs = false;
                    content += userManagement(userUserid);
                    break;
                case "deleteUser":
                    if (accessLevel < 255)
                    {
                        break;
                    }
                    try
                    {
                        userUserid = Convert.ToInt16(getVariable("userid", var.GET));
                    }
                    catch { }
                    showblogs = false;
                    content += deleteUser(userUserid);
                    content += userManagement(0);
                    break;
                case "addUser":
                    if (accessLevel < 255)
                    {
                        break;
                    }
                    showblogs = false;
                    content += addUser();
                    break;
                case "comments":
                    showblogs = false;
                    try
                    {
                        blogID = Convert.ToInt16(getVariable("blogID", var.GET));
                    }
                    catch { }
                    content += comments(blogID);
                    break;
            }
            switch (getVariable("option", var.POST))
            {
                case "Save Blog":
                    if (accessLevel < 100)
                    {
                        break;
                    }
                    try
                    {
                        blogID = Convert.ToInt16(getVariable("blogID", var.POST));
                    }
                    catch { }
                    content += saveBlog(blogID);
                    break;
                case "Save User":
                    if (accessLevel < 255)
                    {
                        break;
                    }
                    showblogs = false;
                    content += saveUser();
                    content += userManagement(0);
                    break;
                case "Save New User":
                    if (accessLevel < 255)
                    {
                        break;
                    }
                    showblogs = false;
                    content += addUser();
                    break;
            }
            if (showblogs)
            {
                content += showBlogs(0);
            }
            
        }
        content += footer();
        Response.Write(content);
    }
    private string showBlogs(int blogID)
    {
        string content = null;
        string select = "SELECT top 30 blogID, blogTitle, blogText, displayName, displayDate, " +
            "CASE " +
                "WHEN showEmail = 1 THEN ' (<a href=\"mailto: ' + email + '\">' + email + '</a>)' " +
                "ELSE '' " +
            "END AS 'email', " +
               "(SELECT COUNT(*) FROM comments WHERE blogID=a.blogID and visible=1) as Comments, " +
               "b.userID " +
        "FROM blogs a " +
            "JOIN users b on " +
                "a.userID=b.userID " +
        "WHERE visible=1 ";
        select += (blogID == 0)? "ORDER BY displayDate Desc" : " AND blogID=" + blogID;

        SqlDataReader dr = query(select);
        if (dr.HasRows)
        {
            while (dr.Read())
            {
                bool allowEdit = (accessLevel == 255 || (accessLevel >= 100 && userid == Convert.ToInt16(dr["userID"]))) ? true : false;

                content += @"<div class='blogEntry'>
                <div class='blogTitle'>
                    <div class='title'>" + dr["blogTitle"] + @"</div>";
                if (allowEdit)
                {
                    content += "<div class='commands'>" +
                        "<a href='default.aspx?option=editBlog&blogID=" + dr["blogID"] + " '>Edit</a> / " +
                        "<a href='default.aspx?option=deleteBlog&blogID=" + dr["blogID"] + "'>Delete</a>" +
                    "</div>";
                }
                content += @"</div>
                <div class='blogSubTitle'>
                    <div class='author'>By " + dr["displayName"] + dr["email"] + @"</div>
                    <div class='date'>" + Convert.ToDateTime(dr["displayDate"]).ToString("hh:mmtt dd MMM yyyy") + @"</div>
                </div>
                <div class='text'>" + Convert.ToString(dr["blogText"]).Replace("\n", "<br>") + @"</div>";
                if (blogID == 0)
                {
                    content += "<div class='comments'><a href='default.aspx?option=comments&blogID=" + dr["blogID"] + "'>Comments (" + dr["Comments"] + @") </a></div>";
                }
                else
                {
                    content += "<div class='comments'><a href='default.aspx?option=postComment&blogID=" + dr["blogID"] + "'>Post Comment</a></div>";
                }
                content += "</div>";
            }
        }
        else
        {
            content = "<div class='error'>";
            content += (blogID > 0) ? "Invalid ID passed" : "There are no blogs currently available";
            content += "</div>";
        }
        dr.Dispose();
        return content;
    }
    private string writeBlog(int blogID)
    {
        string content = null, blogTitle = null, blogText = "", blogDisplayName = displayName, blogEmail = email;
        DateTime displayDate = DateTime.Now, blogCreateDate = DateTime.Now, modifiedDate = DateTime.Now;
        bool visible = true, blogShowEmail = showEmail;
        int numComments = 0;

        if (blogID > 0)
        {
            //editing blog
            string select = @"SELECT a.userID, blogTitle, blogText, visible, a.createDate, displayDate, modifiedDate,
                (SELECT COUNT(*) FROM comments WHERE blogID=a.blogID and visible=1) as Comments,
                displayName, email, showEmail
            FROM blogs a
	            JOIN users b
		            on a.userID = b.userID
            WHERE a.blogID = " + blogID;
            bool mayEdit = false;
            SqlDataReader dr = query(select);
            if (dr.HasRows)
            {
                dr.Read();
                if (accessLevel == 255 || (userid == Convert.ToInt16(dr["userID"])))
                {
                    mayEdit = true;
                    blogTitle = Convert.ToString(dr["blogTitle"]);
                    blogText = Convert.ToString(dr["blogText"]);
                    visible = (Convert.ToInt16(dr["visible"]) == 0) ? false : true;
                    try { blogCreateDate = Convert.ToDateTime(dr["createDate"]); } catch { }
                    try { modifiedDate = Convert.ToDateTime(dr["modifiedDate"]); } catch { }
                    numComments = Convert.ToInt16(dr["Comments"]);
                    blogDisplayName = Convert.ToString(dr["displayName"]);
                    blogEmail = Convert.ToString(dr["email"]);
                    blogShowEmail = (Convert.ToInt16(dr["showEmail"]) == 1) ? true : false;
                }
            }
            dr.Dispose();
            if (!mayEdit)
            {
                return "<div class='error'>Error: Not Authorized</div>";
            }

        }
        content += @"<form method='POST' action='default.aspx' style='display: inline;'><div class='blogEntry'>
            <div class='blogTitle'>
                <div class='title'>Title:<input name='blogTitle' size=60 value='" + blogTitle + @"'> Visible:<input type='checkbox' name='visible'";
        if (visible) { content += " checked"; }
        content += @"</div>
            </div>
            <div class='blogSubTitle'>
                <div class='author'>By " + blogDisplayName;
        if (blogShowEmail) { content += " (<a href=\"mailto: " + blogEmail + "\">" + blogEmail + "</a>)"; }
        content += "</div><div class='date'>";
        if (blogID > 0)
        {
            content += "Display<input name='displayDate' value='" + displayDate + @"'><br>" +
                "Modified<input name='displayDate' value='" + modifiedDate + @"' disabled><br>" +
                "Created<input name='displayDate' value='" + blogCreateDate + @"' disabled><br>";
        }
        else
        {
            content += "<input name='displayDate' value='" + displayDate + @"'>";
        }
        
        content += @"</div>
            </div>
            <div class='text'><textarea name='blogText' rows=10 style='width: 100%;'>" + blogText + @"</textarea></div>
            <div class='comments'>Comments (" + numComments + @")</div>
        </div>
        <input type='hidden' name='blogID' value='" + blogID + @"'>
        <input type='submit' name='option' value='Save Blog'>
        <input type='reset' value='Clear'></form>
        <form action='default.aspx' style='display: inline;'>
            <input type='submit' value='Cancel'>
        </form>";

        return content;
    }
    private string saveBlog(int blogID)
    {
        string content = null;

        //initialize variables
        string select = null;
        string blogTitle = sanitize(getVariable("blogTitle", var.POST), clean.DB);
        string blogText = sanitize(getVariable("blogText", var.POST), clean.DB);
        int visible = (getVariable("visible", var.POST) == "off") ? 0 : 1;
        DateTime displayDate = DateTime.Now;
        try
        {
            displayDate = Convert.ToDateTime(getVariable("displayDate", var.POST));
        }
        catch { }

        if (blogID > 0)
        {
            //edit an existing blog
            if (accessLevel < 255)
            {
                bool mayEdit = false;
                select = "SELECT userid FROM blogs WHERE blogID=" + blogID;
                SqlDataReader dr = query(select);
                if (dr.HasRows)
                {
                    dr.Read();
                    if (userid == Convert.ToInt16(dr["userid"]))
                    {
                        mayEdit = true;
                    }
                }
                dr.Dispose();
                if (!mayEdit)
                {
                    return "<div class='error'>Error: Not Authorized</div>";
                }
            }

            select = @"UPDATE blogs SET 
                blogTitle='" + blogTitle + @"',
                blogText='" + blogText + @"',
                visible=" + visible + @",
                displayDate='" + displayDate + @"',
                modifiedDate=getdate()
            WHERE blogID=" + blogID;
        }
        else
        {
            //create a new blog
            select = @"INSERT INTO blogs
            (userID, blogTitle, blogText, visible, createDate, displayDate, modifiedDate)
                VALUES
            (" + userid + ", '" + blogTitle + "', '" + blogText + "', " + visible + ", getdate(), '" + displayDate + "', getdate())";
            
        }
        query(select);

        return content;
    }
    private string deleteBlog(int blogID)
    {
        string content = null;
        string select = null;

        //see if the user can delete this blog
        if (accessLevel < 255)
        {
            bool mayEdit = false;
            select = "SELECT userid FROM blogs WHERE blogID=" + blogID;
            SqlDataReader dr = query(select);
            if (dr.HasRows)
            {
                dr.Read();
                if (Convert.ToInt16(dr["userid"]) == userid)
                {
                    mayEdit = true;
                }
            }
            dr.Dispose();
            if(!mayEdit){
                return "<div class='error'>Error: Not Authorized</div>";
            }
        }

        select = "UPDATE blogs SET visible=0, modifiedDate=getdate() WHERE blogID=" + blogID;
        query(select);
        content += "<div class='error'>Blog Deleted</div>";
        return content;
    }

    public struct comment
    {
        public int commentID;
        public int userID;
        public int blogID;
        public string displayName;
        public int parentComment;
        public string name;
        public string commentText;
        public DateTime commentDate;
        public string email;
    }
    
    private string comments(int blogID)
    {
        string content = showBlogs(blogID);
        string select = @"SELECT commentID, displayName, parentComment, name, commentText, commentDate,
                      CASE " +
                "WHEN showEmail = 1 THEN ' (<a href=\"mailto: ' + email + '\">' + email + '</a>)' " +
                "ELSE '' " +
            @"END AS 'email', a.userID
          FROM comments a
            LEFT JOIN users b
                on a.userID = b.userID
          WHERE blogID=" + blogID + @"
          ORDER BY commentDate ASC";
        SqlDataReader dr = query(select);
        ArrayList comments = new ArrayList();
        while (dr.Read())
        {
            comment current = new comment();
            current.commentID = Convert.ToInt16(dr["commentID"]);
            current.blogID = blogID;
            current.displayName = Convert.ToString(dr["displayName"]);
            current.parentComment = Convert.ToInt16(dr["parentComment"]);
            current.name = Convert.ToString(dr["name"]);
            current.commentText = Convert.ToString(dr["commentText"]);
            current.commentDate = Convert.ToDateTime(dr["commentDate"]);
            current.email = Convert.ToString(dr["email"]);
            current.userID = Convert.ToInt16(dr["userID"]);
            comments.Add(current);
        }
        dr.Dispose();

        content += "<div style='width: 72%;'>";
        foreach (comment current in comments)
        {
            if (current.parentComment == 0)
            {
                content += mapcomment(current, comments);
            }
        }
        content += "</div>";
        return content;
    }
    private string mapcomment(comment current, ArrayList comments)
    {
        string content = @"<div class='commentContainer'>
            <div class='comment'>
                <div class='header'>";
        content += (current.userID > 0) ? current.displayName : current.name;
        if (current.email.Length > 0)
        {
            content += current.email;
        }
        content += " @ " + current.commentDate.ToString("hh:mmtt ddMMMyyyy");
        if (accessLevel == 255)
        {
            content += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
                "<a href='default.aspx?option=editComment'>Edit</a> / " +
                "<a href='default.aspx?option=deleteComment'>Delete</a>";
        }
        content += @"</div>
                <div class='text'>" + current.commentText.Replace("\n", "<br>") + @"</div>
                <div class='reply'><a href='default.aspx?option=postComment&blogID=" + current.blogID + "&commentID=" + current.commentID + @"'>Reply to Comment</a></div>
            </div>";
        foreach (comment loop in comments)
        {
            if (current.commentID == loop.parentComment)
            {
                content += mapcomment(loop, comments);
            }
        }
        content += "</div>";

        return content;
    }


    #region userManagement

        private string showLogon()
        {
            string content = @"<center><div class='login'>
                <form method='POST' action='default.aspx'>
                    Username: <input name='username'><br>
                    Password: <input name='password' type='password'><br>
                    <div class='button'><input type='submit' value='Log In'></div>";
            if (loginFailed)
            {
                content += "<div class='error'>The username/password combination is invalid</div>";
            }
            content += @"</form>
            </div></center>";

            return content;
        }
        private string userManagement(int userUserid)
        {
            string content = null;
            string select = null;

            select = @"SELECT userid, username, displayName, email, showEmail, createDate, accessLevel,
                (SELECT count(*) FROM blogs WHERE userid = a.userid) as numBlogs,
                (SELECT count(*) FROM blogs WHERE userid = a.userid and visible=1) as numVisibleBlogs,
                (SELECT count(*) FROM comments WHERE userid = a.userid) as numComments,
                (SELECT count(*) FROM comments WHERE userid = a.userid and visible=1) as numVisibleComments
                FROM users a
                ORDER BY username ASC";
            SqlDataReader dr = query(select);
            content += "<table class='userManagement'>" +
            "<thead>" +
                "<tr>" +
                    "<th>UserID</th>" +
                    "<th>Username</th>" +
                    "<th>DisplayName</th>" +
                    "<th>Email</th>" +
                    "<th>ShowEmail</th>" +
                    "<th>Created</th>" +
                    "<th>Access</th>" +
                    "<th>Blogs*</th>" +
                    "<th>Comments*</th>" +
                    "<th></th>" +
                "</tr>" +
            "</thead>" +
            "<tbody>";
            string lineClass = null;
            while (dr.Read())
            {
                string userShowEmail = (Convert.ToInt16(dr["showEmail"]) == 1) ? "Yes" : "No";
                string userAccess = null;
                if (Convert.ToInt16(dr["accessLevel"]) == 255)
                {
                    userAccess = "Admin";
                }
                else if (Convert.ToInt16(dr["accessLevel"]) >= 100)
                {
                    userAccess = "Blogger";
                }
                else
                {
                    userAccess = "User";
                }
                lineClass = (lineClass == "even") ? "odd" : "even";

                if (userUserid == Convert.ToInt16(dr["userid"]))
                {
                    string showEmailSelect = "<select name='showEmail'>" +
                        "<option value=0";
                    showEmailSelect += (userShowEmail == "No") ? " selected" : "";
                    showEmailSelect += ">No</option>" +
                        "<option value=1";
                    showEmailSelect += (userShowEmail == "Yes") ? " selected" : "";
                    showEmailSelect += ">Yes</option>" +
                    "</select>";

                    string accessLevelSelect = "<select name='accessLevel'>" +
                        "<option value='255'";
                    accessLevelSelect += (userAccess == "Admin") ? " selected" : "";
                    accessLevelSelect += ">Admin</option>" +
                        "<option value='100'";
                    accessLevelSelect += (userAccess == "Blogger") ? " selected" : "";
                    accessLevelSelect += ">Blogger</option>" +
                        "<option value='0'";
                    accessLevelSelect += (userAccess == "User") ? " selected" : "";
                    accessLevelSelect += ">User</option>" +
                    "</select>";

                    content += "<form method='POST' action='default.aspx'>" +
                    "<tr class='" + lineClass + "'>" +
                        "<td>" + dr["userid"] + "</td>" +
                        "<td><input name='username' value='" + dr["username"] + "'></td>" +
                        "<td><input name='displayName' value='" + dr["displayName"] + "'></td>" +
                        "<td><input name='email' value='" + dr["email"] + "'></td>" +
                        "<td>" + showEmailSelect + "</td>" +
                        "<td>" + dr["createDate"] + "</td>" +
                        "<td>" + accessLevelSelect + "</td>" +
                        "<td>" + dr["numBlogs"] + " (" + dr["numVisibleBlogs"] + ")</td>" +
                        "<td>" + dr["numComments"] + " (" + dr["numVisibleComments"] + ")</td>" +
                        "<td>" +
                            "<input type='hidden' name='userid' value='" + userUserid + "'>" +
                            "<input type='submit' name='option' value='Save User'></form>" +
                            "<form action='default.aspx' method='GET'>" +
                            "<input type='hidden' name='option' value='userManagement'>" +
                            "<input type='submit' value='Cancel'></form>" +
                        "</td>" +
                    "</tr>";
                }
                else
                {
                    content += "<tr class='" + lineClass + "'>" +
                        "<td>" + dr["userid"] + "</td>" +
                        "<td>" + dr["username"] + "</td>" +
                        "<td>" + dr["displayName"] + "</td>" +
                        "<td>" + dr["email"] + "</td>" +
                        "<td>" + userShowEmail + "</td>" +
                        "<td>" + dr["createDate"] + "</td>" +
                        "<td>" + userAccess + "</td>" +
                        "<td>" + dr["numBlogs"] + " (" + dr["numVisibleBlogs"] + ")</td>" +
                        "<td>" + dr["numComments"] + " (" + dr["numVisibleComments"] + ")</td>" +
                        "<td>" +
                            "<a href='default.aspx?option=editUser&userid=" + dr["userid"] + "'>Edit</a> / " +
                            "<a href='default.aspx?option=deleteUser&userid=" + dr["userid"] + "'>Delete</a>" +
                        "</td>" +
                    "</tr>";
                }
            }
            content += @"</tbody>
            <tfoot>
                <tr>
                    <td colspan=10>* total (visible)<br>
                        <a href='default.aspx?option=addUser'>Add User</a>
                    </td>
                </tr>
            </tfoot>
            </table>";
            dr.Dispose();
            return content;
        }
        private string saveUser()
        {
            string content = null;

            //get variables
            string userUsername = sanitize(getVariable("username", var.POST), clean.DB);
            string userDisplayName = sanitize(getVariable("displayName", var.POST), clean.DB);
            string userEmail = sanitize(getVariable("email", var.POST), clean.DB);
            int userShowEmail = (getVariable("showEmail", var.POST) == "1") ? 1 : 2;
            int userAccessLevel = Convert.ToInt16(getVariable("accessLevel", var.POST));
            int userUserid = Convert.ToInt16(getVariable("userid", var.POST));

            //update user
            string select = "UPDATE users " +
                "SET username='" + userUsername + "'," +
                    " displayName='" + userDisplayName + "', " +
                    " email='" + userEmail + "', " +
                    " showEmail='" + userShowEmail + "', " +
                    " accessLevel='" + userAccessLevel + "' " +
                "WHERE userid=" + userUserid;
            SqlDataReader dr = query(select);
            content += "<div class='error'>" + dr.RecordsAffected + " Record(s) Affected</div>";
            dr.Dispose();

            return content;
        }
        private string deleteUser(int userUserid)
        {
            string content = null;
            string select = "DELETE FROM users WHERE userid=" + userUserid;
            SqlDataReader dr = query(select);
            content += "<div class='error'>" + dr.RecordsAffected + " Record(s) Affected</div>";
            dr.Dispose();

            return content;
        }
        private string addUser()
        {
            string content = null;

            string userUsername = null, userDisplayname = null, userEmail = null;
            int userShowEmail = 0, userAccessLevel = 0;

            ArrayList errors = new ArrayList();
            if (getVariable("option", var.POST) == "Save New User")
            {
                //save a new user
                userUsername = sanitize(getVariable("username", var.POST), clean.DB);
                userDisplayname = sanitize(getVariable("displayName", var.POST), clean.DB);
                userEmail = sanitize(getVariable("email", var.POST), clean.DB);
                userShowEmail = (getVariable("showEmail", var.POST) == "1") ? 1 : 0;
                userAccessLevel = Convert.ToInt16(getVariable("userAccessLevel", var.POST));

                string password1 = getVariable("password1", var.POST);
                string password2 = getVariable("password2", var.POST);
                if (password1 != password2)
                {
                    errors.Add("Passwords don't match.");
                }//checking to see if passwords match
                else if (password1 == null || password1.Length < 6)
                {
                    errors.Add("Password needs to be at least 6 characters long.");
                }

                if (userAccessLevel != 0 && userAccessLevel != 100 && userAccessLevel != 255)
                {
                    errors.Add("Invalid access level");
                }//verify the access level is a valid value

                //verify the info doesn't already exist
                string select = @"SELECT count(*) 
                    FROM users 
                    WHERE displayName='" + userDisplayname + @"'";
                SqlDataReader dr = query(select);
                dr.Read();
                if (Convert.ToInt16(dr.GetValue(0)) > 0)
                {
                    errors.Add("Display name already exists.");
                }
                dr.Dispose();

                select = @"SELECT count(*) 
                    FROM users 
                    WHERE username='" + userUsername + @"'";
                dr = query(select);
                dr.Read();
                if (Convert.ToInt16(dr.GetValue(0)) > 0)
                {
                    errors.Add("User name already exists.");
                }
                dr.Dispose();

                select = @"SELECT count(*) 
                    FROM users 
                    WHERE email='" + userEmail + @"'";
                dr = query(select);
                dr.Read();
                if (Convert.ToInt16(dr.GetValue(0)) > 0)
                {
                    errors.Add("Email already exists.");
                }
                dr.Dispose();

                if (errors.Count == 0)
                {
                    //no errors, save new user
                    select = @"INSERT INTO users
                        (username, password, displayName, email, showEmail, createDate, accessLevel)
                    VALUES
                        ('" + userUsername + "', '" + FormsAuthentication.HashPasswordForStoringInConfigFile(password1, "MD5") + "', '" + userDisplayname + "', '" + userEmail + "', " + userShowEmail + ", getDate(), " + userAccessLevel + ")";
                    dr = query(select);
                    if (dr.RecordsAffected > 0)
                    {
                        errors.Add("User Added");
                        userUsername = null;
                        userDisplayname = null;
                        userEmail = null;
                    }
                    else
                    {
                        errors.Add("There has been an error.  No records were added.");
                    }
                    dr.Dispose();
                }
            }//end save new user section

            content += "<form method='POST' action='default.aspx' style='display: inline;'>" +
            "<table class='addUser'>" +
            "<tbody>" +
                "<tr>" +
                    "<th>Username</th>" +
                    "<td><input name='username' value='" + userUsername + "'></td>" +
                "</tr><tr>" +
                    "<th>Display Name</th>" +
                    "<td><input name='displayName' value='" + userDisplayname + "'></td>" +
                "</tr><tr>" +
                    "<th>Email</th>" +
                    "<td><input name='email' value='" + userEmail + "'></td>" +
                "</tr><tr>" +
                    "<th>ShowEmail</th>" +
                    "<td><select name='showEmail'>" +
                        "<option value=0";
            content += (userShowEmail == 0) ? " selected" : "";
            content += ">No</option>" +
                        "<option value=1";
            content += (userShowEmail == 1) ? " selected" : "";
            content += ">Yes</option" +
                        "</select>" +
                    "</td>" +
                "</tr><tr>" +
                    "<th>Access</th>" +
                    "<td><select name='accessLevel'>" +
                        "<option value=0";
            content += (userAccessLevel == 0) ? " selected" : "";
            content += ">User</option>" +
                        "<option value=100";
            content += (userAccessLevel == 100) ? " selected" : "";
            content += ">Blogger</option>" +
                        "<option value=255";
            content += (userAccessLevel == 255) ? " selected" : "";
            content += ">Admin</option>" +
                        "</select>" +
                    "</td>" +
                "</tr><tr>" +
                    "<th>Password</th>" +
                    "<td><input type='password' name='password1'></td>" +
                "</tr><tr>" +
                    "<th>Verify</th>" +
                    "<td><input type='password' name='password2'></td>" +
                "</tr><tr>" +
                    "<td colspan=2 class='error'>";
            foreach (string error in errors)
            {
                content += error + "<br>";
            }
            content += "</td>" +
                "</tr><tr>" +
                    "<td colspan=2>" +
                        "<input type='submit' name='option' value='Save New User'></form>" +
                        "<form action='default.aspx' method='GET' style='display: inline;'>" +
                            "<input type='hidden' name='option' value='userManagement'>" +
                            "<input type='submit' value='Cancel'>" +
                        "</form>" +
                "</tr>" +
            "</tbody>" +
            "</table>";
            return content;
        }

    #endregion
    #region layout

        private string header()
        {
            string content = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"" +
                 "\"http://www.w3.org/TR/html4/strict.dtd\">" +
             @"<html>
        <head>
            <title>cSharp Blog</title>
            <link rel='stylesheet' type='text/css' href='style.css'>
        </head>
        <body>";
            return content;
        }
        private string layout()
        {
            string content = @"            <center><img src='header.png'></center>
            <div class='rightBar'>
                <div class='title'>C# Blog Menu</div>
                <ul>
                    <li>";
            content += (loggedIn) ? "<a href='default.aspx?logon=false'>Log Out</a>" : "<a href='default.aspx?logon=true'>Log In </a>";
            content += "</li>";
            if (loggedIn && accessLevel == 255)
            {
                content += "<li><a href='default.aspx?option=userManagement'>User Management</a></li>";
            }
            if (loggedIn && accessLevel >= 100)
            {
                content += @"<li><a href='default.aspx?option=writeBlog'>Write Blog Entry</a></li>
                        <li><a href=''>See New Entries</a></li>";
            }
            content += @"</ul>
            </div>";
            return content;
        }
        private string footer()
        {
            string content = "</body></html>";
            return content;
        }

    #endregion

    private void authenticate()
{
    string _username = null, password = null;
    if (getVariable("logon", var.GET) == "false")
    {
        cookie(false, null);
        return;
    }
    if (getVariable("username", var.POST) != null && getVariable("password", var.POST) != null)
    {   //check for POST vars from the login form
        _username = sanitize(getVariable("username", var.POST), clean.DB);
        password = FormsAuthentication.HashPasswordForStoringInConfigFile(getVariable("password", var.POST), "MD5");
    }
    else if (Session["blogUsername"] != null && Session["blogPassword"] != null)
    {   //check for sessions
        _username = sanitize(Session["blogUsername"].ToString(), clean.DB);
        password = sanitize(Session["blogPAssword"].ToString(), clean.DB);
    }
    else
    {   //check for cookies
        HttpCookie usernameCookie = HttpContext.Current.Request.Cookies["blogUsername"];
        HttpCookie passwordCookie = HttpContext.Current.Request.Cookies["blogPassword"];
        if (usernameCookie != null && passwordCookie != null)
        {
            _username = sanitize(usernameCookie.Value, clean.DB);
            password = sanitize(passwordCookie.Value, clean.DB);
        }
    }

    if (_username == null || password == null)
    {
        return;
    }

    string select = "SELECT userid, username, displayName, email, showEmail, createDate, accessLevel " + 
        "FROM users WHERE username='" + _username + "' AND password='" + password + "'";
    SqlDataReader dr = query(select);
    if (dr.HasRows)
    {
        dr.Read();
        loggedIn = true;
        userid = Convert.ToInt16(dr["userid"]);
        username = Convert.ToString(dr["username"]);
        displayName = Convert.ToString(dr["displayName"]);
        email = Convert.ToString(dr["email"]);
        showEmail = (Convert.ToInt16(dr["showEmail"]) == 1) ? true : false;
        createDate = Convert.ToDateTime(dr["createDate"]);
        accessLevel = Convert.ToInt16(dr["accessLevel"]);
        cookie(true, password); //set cookies and sessions
    }
    else
    {
        loggedIn = false;
        if (getVariable("username", var.POST) != null && getVariable("password", var.POST) != null)
        {
            loginFailed = true; //remove any sessions or cookies
        }
        cookie(false, null);
    }
    dr.Dispose();        
}
    private void cookie(bool set, string password)
    {
        HttpCookie usernameCookie = new HttpCookie("blogUsername");
        HttpCookie passwordCookie = new HttpCookie("blogPassword");
        switch (set)
        {
            case true:
                //set cookies
                usernameCookie.Value = username;
                passwordCookie.Value = password;
                usernameCookie.Expires = System.DateTime.Now.AddHours(24);
                passwordCookie.Expires = System.DateTime.Now.AddHours(24);
                HttpContext.Current.Response.Cookies.Add(usernameCookie);
                HttpContext.Current.Response.Cookies.Add(passwordCookie);

                //set sessions
                Session["blogUsername"] = username;
                Session["blogPassword"] = password;
                break;
            case false:
                //set cookies to expire yesterday
                usernameCookie = HttpContext.Current.Request.Cookies["blogUsername"];
                passwordCookie = HttpContext.Current.Request.Cookies["blogPassword"];
                try
                {
                    usernameCookie.Expires = DateTime.Now.AddDays(-1);
                    HttpContext.Current.Response.Cookies.Add(usernameCookie);
                }
                catch { }
                try
                {
                    passwordCookie.Expires = DateTime.Now.AddDays(-1);
                    HttpContext.Current.Response.Cookies.Add(passwordCookie);
                }
                catch { }

                //kill sessions
                Session.Abandon();
                break;
        }
    }
    private SqlDataReader query(string select)
    {
        SqlConnection conn = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["blogDatabase"].ConnectionString);
        conn.Open();
        SqlCommand cm = new SqlCommand(select, conn);
        return cm.ExecuteReader(CommandBehavior.CloseConnection);
    }
    private string getVariable(string input, var varType)
    {
        string variable = null;
        switch (varType)
        {
            case var.GET:
                try
                {
                    int doesVarExist = Request.QueryString[input].Length;
                    variable = Request.QueryString[input];
                }
                catch { }
                break;
            case var.POST:
                try
                {
                    if (Request.Form.Get(input).Length > 0)
                    {
                        variable = Request.Form.Get(input);
                    }
                }
                catch { }
                break;
        }
        
        return variable;
    }
    private string sanitize(string value, clean type)
    {
        switch (type)
        {
            case clean.DB:
                value = value.Replace("'", "''");
                break;
        }

        return value;
    }

}
